// ==UserScript==
// @name        Endchan Select After
// @namespace   Endchan
// @include     https://endchan.gg/*/res/*
// @include     https://endchan.net/*/res/*
// @include     https://endchan.org/*/res/*
// @include     http://kqrtg5wz4qbyjprujkz33gza7r73iw3ainqp1mz5zmu16symcdwy.loki/*/res/*
// @include     http://endchancxfbnrfgauuxlztwlckytq7rgeo5v6pc2zd4nyqo3khfam4ad.onion/*/res/*
// @include     http://enxx3byspwsdo446jujc52ucy2pf5urdbhqw3kbsfhlfjwmbpj5smdad.onion/*/res/*
// @include     https://endchan.gg/mod.js?boardUri=*
// @include     https://endchan.net/mod.js?boardUri=*
// @include     https://endchan.org/mod.js?boardUri=*
// @include     http://kqrtg5wz4qbyjprujkz33gza7r73iw3ainqp1mz5zmu16symcdwy.loki/mod.js?boardUri=*
// @include     http://endchancxfbnrfgauuxlztwlckytq7rgeo5v6pc2zd4nyqo3khfam4ad.onion/mod.js?boardUri=*
// @include     http://enxx3byspwsdo446jujc52ucy2pf5urdbhqw3kbsfhlfjwmbpj5smdad.onion/mod.js?boardUri=*
// @version     1.1
// @grant       none
// ==/UserScript==


/* ==== Description ==== */
/*
Adds a button to the head row of each post within a thread and moderation view.
The button allows to select all the post following that particular one.
This just marks the checkboxes, you  still have to hit delete at the bottom of the page.
*/


// =================================
/* ==== Variable Definitions ==== */
// get all the checkboxes
var allPosts = document.querySelectorAll(".postCell");



// =========================
/* ==== Preparing UI ==== */
// creating new element for the selection button
var selectAfterButton = createAction("Banana");
// adds one instance of the button to each post
for (var i = 0; i < allPosts.length; i++) {
  allPosts[i].querySelector(".delLink").after(selectAfterButton.cloneNode(true));
}

// call the function that places the evenlisteners on the buttons
addSelectEvent();



// ==================================
/* ====  Function Definitions  ====*/
// this is called when clicked on a Select After button
// runs through the posts, compares the ID with the ID of the used post
// and marks all the posts that has higher number / made after that post
function selectAfter() {
  var thisNum = Number(this.closest(".postCell").getAttribute("id"));
  for (var i = 0; i < allPosts.length; i++) {
    var postNum = Number(allPosts[i].getAttribute("id"));
    if (postNum > thisNum) {
        allPosts[i].querySelector(".deletionCheckBox").checked = true;
    }
  }
}


// places eventlisteners on all the new buttons
function addSelectEvent() {
  var sels = document.querySelectorAll(".selectAfter");
  for (var i = 0; i < sels.length; i++) {
    sels[i].addEventListener("click", selectAfter);
  }
}

// to create a new span element
// which will be used as a button
function createAction(text) {
  var genericSpan = document.createElement("span");
  genericSpan.style.color = "red";
  genericSpan.style.cursor = "pointer";
  genericSpan.style.paddingLeft = "4px";
  genericSpan.textContent = text;
  genericSpan.setAttribute("class", "selectAfter");
  return genericSpan;
}
